package com.yidian.shenghuoquan.bpush.app

import android.content.Context
import com.yidian.bcommon.app.YdBaseApplication
import com.yidian.bcommon.services.ZapServiceNameConstants
import com.yidian.news.util.ProcessUtil
import com.yidian.shenghuoquan.bpush.base.BPush
import com.yidian.shenghuoquan.bpush.service.PushService
import com.yidian.yac.core.core.YacModuleSpec
import com.yidian.yac.core.zap.Zap
import timber.log.Timber

@YacModuleSpec
class BPushApplication: YdBaseApplication() {
  companion object {
    lateinit var context:Context
  }
  override fun onCreate() {
    super.onCreate()
    context = this;
    if (ProcessUtil.isMainProcess(this)) {
      registerXpage()
      initService()
    }
    BPush().init(this)
  }

  private fun registerXpage() {

  }

  private fun initService() {
    Timber.tag("BPushApplication").i("initService")
    Zap.addService(ZapServiceNameConstants.BPush, PushService())
  }
}
