package com.yidian.shenghuoquan.bpush.push.mipush

import android.app.ActivityManager
import android.content.Context
import android.os.Process
import com.xiaomi.mipush.sdk.MiPushClient
import com.yidian.shenghuoquan.bpush.app.BPushApplication
import com.yidian.shenghuoquan.bpush.constant.BrandConstant
import com.yidian.shenghuoquan.bpush.constant.Constant
import com.yidian.shenghuoquan.bpush.push.PushPolicy
import com.yidian.xarc.xevent.BuildConfig
import com.yidian.xarc.xevent.XBaseEvent
import com.yidian.xarc.xevent.XEventManager
import org.greenrobot.eventbus.Subscribe
import org.greenrobot.eventbus.ThreadMode
import timber.log.Timber

class MiPushPolicy: PushPolicy() {
  companion object {
    var appId = "2882303761519906361"
    var appkey = "5871990645361"
    const val packageName = "com.shenghuoquan.business"
  }
  override fun initPushSdk() {
    Timber.tag("MiPushPolicy").i("initPushSdk")
    initAppkey()
    XEventManager.register(this)
    pushStatus = Constant.pushConnected;
    if (shouldInit()) {
      MiPushClient.registerPush(BPushApplication.context, appId, appkey)
    }
  }

  override fun pubMessage(message: String) {
    TODO("Not yet implemented")
  }

  private fun shouldInit(): Boolean {
    val am = BPushApplication.context.getSystemService(Context.ACTIVITY_SERVICE) as ActivityManager
    val processInfos = am.runningAppProcesses
    val mainProcessName: String = BPushApplication.context.getPackageName()
    val myPid = Process.myPid()
    for (info in processInfos) {
      if (info.pid == myPid && mainProcessName == info.processName) {
        return true
      }
    }
    return false
  }

  @Subscribe(sticky = false, threadMode = ThreadMode.MAIN)
  fun onEvent(event: XBaseEvent?) {
    Timber.tag("MiPushPolicy").i("event name ${event?.name}, event body is ${event?.body}")
    when (event?.name) {
      Constant.pushConnectedEvent -> pushStatus = Constant.pushConnected
    }
  }

  fun initAppkey() {
    if (BrandConstant.DEBUG) {
      appId = "2882303761520001960"
      appkey = "5612000187960"
    }
  }
}
