package com.yidian.shenghuoquan.bpush.push.mipush.receiver

import android.annotation.SuppressLint
import android.content.Context
import android.os.Message
import android.text.TextUtils
import com.xiaomi.mipush.sdk.*
import com.yidian.shenghuoquan.bpush.constant.Constant
import com.yidian.xarc.xevent.XBaseEvent
import com.yidian.xarc.xevent.XEventManager
import timber.log.Timber
import java.text.SimpleDateFormat
import java.util.*

class MiPushReceiver : PushMessageReceiver() {

  private val TAG: String? = "MiPushReceiver"
  private var mRegId: String? = null
  private var mTopic: String? = null
  private var mAlias: String? = null
  private var mAccount: String? = null
  private var mStartTime: String? = null
  private var mEndTime: String? = null

  override fun onReceivePassThroughMessage(context: Context, message: MiPushMessage) {
    Timber.tag(TAG).i("onReceivePassThroughMessage is called. $message")
    if (!TextUtils.isEmpty(message.topic)) {
      mTopic = message.topic
    } else if (!TextUtils.isEmpty(message.alias)) {
      mAlias = message.alias
    }
    val msg = Message.obtain()
  }

  override fun onNotificationMessageClicked(context: Context, message: MiPushMessage) {
    Timber.tag(TAG).i("onNotificationMessageClicked is called. $message")
    if (!TextUtils.isEmpty(message.topic)) {
      mTopic = message.topic
    } else if (!TextUtils.isEmpty(message.alias)) {
      mAlias = message.alias
    }
    val msg = Message.obtain()
  }

  override fun onNotificationMessageArrived(context: Context, message: MiPushMessage) {
    Timber.tag(TAG).i("onNotificationMessageArrived is called. $message")
    if (!TextUtils.isEmpty(message.topic)) {
      mTopic = message.topic
    } else if (!TextUtils.isEmpty(message.alias)) {
      mAlias = message.alias
    }
  }

  override fun onCommandResult(context: Context, message: MiPushCommandMessage) {
    Timber.tag(TAG).i("onCommandResult is called. $message")
    val command = message.command
    val arguments = message.commandArguments
    val cmdArg1 = if (arguments != null && arguments.size > 0) arguments[0] else null
    val cmdArg2 = if (arguments != null && arguments.size > 1) arguments[1] else null
    val log: String
    if (MiPushClient.COMMAND_REGISTER == command) {
      if (message.resultCode == ErrorCode.SUCCESS.toLong()) {
        mRegId = cmdArg1
        val event = XBaseEvent(Constant.pushConnectedEvent, Constant.pushConnected)
        XEventManager.post(event)
      } else {
      }
    } else if (MiPushClient.COMMAND_SET_ALIAS == command) {
      if (message.resultCode == ErrorCode.SUCCESS.toLong()) {
        mAlias = cmdArg1
      } else {
      }
    } else if (MiPushClient.COMMAND_UNSET_ALIAS == command) {
      if (message.resultCode == ErrorCode.SUCCESS.toLong()) {
        mAlias = cmdArg1
      } else {
      }
    } else if (MiPushClient.COMMAND_SET_ACCOUNT == command) {
      if (message.resultCode == ErrorCode.SUCCESS.toLong()) {
        mAccount = cmdArg1
      } else {
      }
    } else if (MiPushClient.COMMAND_UNSET_ACCOUNT == command) {
      if (message.resultCode == ErrorCode.SUCCESS.toLong()) {
        mAccount = cmdArg1
      } else {
      }
    } else if (MiPushClient.COMMAND_SUBSCRIBE_TOPIC == command) {
      if (message.resultCode == ErrorCode.SUCCESS.toLong()) {
        mTopic = cmdArg1
      } else {
      }
    } else if (MiPushClient.COMMAND_UNSUBSCRIBE_TOPIC == command) {
      if (message.resultCode == ErrorCode.SUCCESS.toLong()) {
        mTopic = cmdArg1
      } else {
      }
    } else if (MiPushClient.COMMAND_SET_ACCEPT_TIME == command) {
      if (message.resultCode == ErrorCode.SUCCESS.toLong()) {
        mStartTime = cmdArg1
        mEndTime = cmdArg2
      } else {
      }
    } else {
      log = message.reason
    }
  }

  override fun onReceiveRegisterResult(context: Context, message: MiPushCommandMessage) {
    Timber.tag(TAG).i("onReceiveRegisterResult is called. $message")
    val command = message.command
    val arguments = message.commandArguments
    val cmdArg1 = if (arguments != null && arguments.size > 0) arguments[0] else null
    val log: String
    if (MiPushClient.COMMAND_REGISTER == command) {
      if (message.resultCode == ErrorCode.SUCCESS.toLong()) {
        mRegId = cmdArg1
      } else {
      }
    } else {
      log = message.reason
    }

  }

  @SuppressLint("SimpleDateFormat")
  private fun getSimpleDate(): String {
    return SimpleDateFormat("MM-dd hh:mm:ss").format(Date())
  }

}
