package com.yidian.shenghuoquan.bpush.push.oppopush

import com.heytap.msp.push.HeytapPushManager
import com.heytap.msp.push.callback.ICallBackResultService
import com.yidian.shenghuoquan.bpush.app.BPushApplication
import com.yidian.shenghuoquan.bpush.push.PushPolicy
import timber.log.Timber

class OppoPushPolicy: PushPolicy(), ICallBackResultService {
  companion object{
    const val appKey = "d4553310f4704936bb48f2d1e5f7da22"
    const val appSecret = "31e239f66ce64309afd65e627fe44cf0"
  }
  override fun initPushSdk() {
    Timber.tag("OppoPushPolicy").i("Oppo push sdk init")
    HeytapPushManager.init(BPushApplication.context, true);
    if (HeytapPushManager.isSupportPush()) {
      HeytapPushManager.register(BPushApplication.context, appKey, appSecret, this)
    } else {
      Timber.tag("OppoPushPolicy").i("not support oppo push")
      return
    }
  }

  override fun pubMessage(message: String) {
    Timber.tag("OppoPushPolicy").i("message is $message")
  }

  override fun onRegister(code: Int, regId: String?) {
    Timber.tag("OppoPushPolicy").i("register id is $regId")
  }

  override fun onUnRegister(code: Int) {
    Timber.tag("OppoPushPolicy").i("unrgister result code is $code")
  }

  override fun onSetPushTime(code: Int, s: String?) {
    Timber.tag("OppoPushPolicy").i("code is $code, s is $s")
  }

  override fun onGetPushStatus(code: Int, status: Int) {
    Timber.tag("OppoPushPolicy").i("code is $code, status is $status")
  }

  override fun onGetNotificationStatus(code: Int, status: Int) {
    Timber.tag("OppoPushPolicy").i("code is $code, status is $status")
  }
}
