package com.yidian.shenghuoquan.bpush.push.umengpush

import android.content.Context
import com.umeng.message.IUmengRegisterCallback
import com.umeng.message.PushAgent
import com.umeng.message.UmengMessageHandler
import com.umeng.message.entity.UMessage
import com.yidian.shenghuoquan.bpush.app.BPushApplication
import com.yidian.shenghuoquan.bpush.constant.Constant
import com.yidian.shenghuoquan.bpush.push.PushPolicy
import timber.log.Timber

class UmengPushPolicy: PushPolicy(), IUmengRegisterCallback {
//  val mPushAgent = PushAgent.getInstance(BPushApplication.context)

  val messageHandler = object :UmengMessageHandler() {
    override fun dealWithCustomMessage(p0: Context?, p1: UMessage?) {
      super.dealWithCustomMessage(p0, p1)
      //todo向其他组件提供消息

    }
  }

  override fun initPushSdk() {
//    mPushAgent.register(this)
  }

  override fun pubMessage(message: String) {

  }

  override fun onSuccess(p0: String?) {
    Timber.tag("UmengPushPolicy").i("register success token is $p0")
    pushStatus = Constant.pushConnected
//    mPushAgent.messageHandler = messageHandler
  }

  override fun onFailure(p0: String?, p1: String?) {
    Timber.tag("UmengPushPolicy").i("register failture p0 is $p0, p1 is $p1")
  }

  public fun initUmengPush(context: Context) {
    val pushAgent:PushAgent = PushAgent.getInstance(context)
    pushAgent.messageHandler = object: UmengMessageHandler() {
      override fun dealWithCustomMessage(p0: Context?, p1: UMessage?) {
        super.dealWithCustomMessage(p0, p1)
        Timber.tag("UmengPushPolicy").i("custom message $p1")
      }
    }
    pushAgent.register(object: IUmengRegisterCallback{
      override fun onSuccess(p0: String?) {
        Timber.tag("UmengPushPolicy").i("register success token is $p0")
      }

      override fun onFailure(p0: String?, p1: String?) {
        Timber.tag("UmengPushPolicy").i("register failture $p0, $p1")
      }
    })


  }
}
